use serde::{Deserialize, Serialize};

pub mod read;
pub mod write;

#[derive(Clone, Debug, PartialEq, Eq, Serialize, Deserialize)]
pub enum Kind {
    Read(read::Read),
    Write(write::Write),
    Math(Math),
    Blend(Blend),
    Noise(Noise),
    Filter(Filter),
}

#[derive(Clone, Debug, PartialEq, Eq, Serialize, Deserialize)]
pub enum Math {
    Add,
    Subtract,
    Multiply,
    Divide,
}

#[derive(Clone, Debug, PartialEq, Eq, Serialize, Deserialize)]
pub enum Blend {
    Normal,
    Multiply,
    Additive,
    Overlay,
    Screen,
    Subtractive,
    Difference,
    Darken,
    Lighten,
}

#[derive(Clone, Debug, PartialEq, Eq, Serialize, Deserialize)]
pub enum Noise {
    Perlin,
    Simplex,
    Voronoi,
}

#[derive(Clone, Debug, PartialEq, Eq, Serialize, Deserialize)]
pub enum Filter {
    Invert,
}
